/*  Gaby
 *  Copyright (C) 1998 Frederic Peters
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#define MAX_RECORDS	9999	/* if you want more, change this */
#define MAX_LABELS	20

/* available flags */
#define         FULLNAME        1
#define         DATE            2
#define         TIME            3
#define         NUMERIC         4

int nlabels;

typedef struct _record record;
typedef struct _book book;

struct _record {
	GString *info[MAX_LABELS];
	gint frombook;
	gboolean shown;
};

struct _book {
	gboolean shown;
	gboolean deleted;
	GString *filename;
};

GList *all_records;
GList *all_bases;
gint nbook;

void base_init();
gboolean base_add ( char *filename );
gboolean base_visibility ( gint nbk, gboolean isshown );
gboolean base_write ( gint nbook );
gboolean base_sort ( gint col );
gboolean base_remove ( gint nbook );

gboolean record_add (GString *st, gint fn);
gboolean record_remove(gint shown_record);
gint record_goto(gint nb);
gint record_select(GString *what, gint ncol, gint type);
gint* bases_vsblt(gint *az);
gint record_goto_str(GString *val, gint field, gint startfrom);

