/*  Gaby
 *  Copyright (C) 1998 Frederic Peters
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "gaby.h"
#include <gtk/gtk.h>
#include "dlg_about.h"

static GtkWidget *win;

static void ok_clicked (GtkObject *object, gpointer user_data)
{
	gtk_widget_destroy (win);
	win = NULL;
}

GtkWidget* create_about_window ()
{
	GtkWidget *dialog_vbox;
	GtkWidget *dialog_action_area;
	GtkWidget *vbox2;
	GtkWidget *label;
	GtkWidget *hbox1;
	GtkWidget *hbb;
	GtkWidget *ok;
	GString *st;
	
	win = gtk_dialog_new ();
	gtk_window_set_title (GTK_WINDOW (win), _("About Gaby"));
	gtk_window_position (GTK_WINDOW (win), GTK_WIN_POS_MOUSE);
	gtk_window_set_policy (GTK_WINDOW (win), TRUE, TRUE, FALSE);

	dialog_vbox = GTK_DIALOG (win)->vbox;
	gtk_widget_show (dialog_vbox);
	
	vbox2 = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (vbox2);
	gtk_box_pack_start (GTK_BOX (dialog_vbox), vbox2, TRUE, TRUE, 0);

	switch ( prog ) {
		case 1:
		{
			label = gtk_label_new ( \
				_("gaby\nThe Gaby Address Book of Yesterday"));
		} break;
		case 2:
		{
			label = gtk_label_new ( _("gbc\nThe Gaby Book Case"));
		} break;
		default:
		{
			label = gtk_label_new ( _("auk : an unknown base"));
		} break;
	}
			
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, TRUE, TRUE, 5);

	st = g_string_new(_("Version "));
	st = g_string_append(st, VERSION);
	label = gtk_label_new (st->str);
	g_string_free(st, 1);
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (vbox2), label, FALSE, TRUE, 5);

	hbox1 = gtk_hbox_new (TRUE, 0);
	gtk_widget_show (hbox1);
	gtk_box_pack_start (GTK_BOX (vbox2), hbox1, TRUE, TRUE, 0);

	label = gtk_label_new (_("Mail your congratulations,\npatches and bug reports to :\nfpeters@multimania.com"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, TRUE, 5);
	gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_LEFT);
	gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

	label = gtk_label_new (_("The latest release will\nalways be available at :\nhttp://gaby.netpedia.net/"));
	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (hbox1), label, FALSE, TRUE, 5);
	gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_RIGHT);

	dialog_action_area = GTK_DIALOG (win)->action_area;
	gtk_widget_show (dialog_action_area);
	gtk_container_border_width (GTK_CONTAINER (dialog_action_area), 10);
	
	hbb = gtk_hbutton_box_new ();
	gtk_widget_show (hbb);
	gtk_box_pack_start (GTK_BOX (dialog_action_area), hbb, FALSE, TRUE, 0);
	gtk_container_border_width (GTK_CONTAINER (hbb), 5);

	ok = gtk_button_new_with_label ("OK");
	gtk_widget_show (ok);
	gtk_container_add (GTK_CONTAINER (hbb), ok);
	gtk_signal_connect (GTK_OBJECT(ok),"clicked", \
				GTK_SIGNAL_FUNC(ok_clicked),NULL);
	return win;
}

/*
 * Le long des golfes, pas trs clairs ...
 */

