/*  Gaby
 *  Copyright (C) 1998 Frederic Peters
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "gaby.h"
#include <gtk/gtk.h>
#include "main.h"
#include "dlg_config.h"
#include "dlg_book.h"
#include "form.h"
#include "list.h"

static GtkWidget *winsave;
static GtkWidget *winremove;

static gint wbsave=1;
static gint wbremove=1;

static void ok_clicked (GtkObject *object, gint user_data)
{
	switch ( user_data ) {
		case 1:	/* remove */
		{
			base_remove(wbremove);
			gtk_widget_destroy(winremove);
			list_books_changed = TRUE;
			shown_record = 0;
			show_record_inform();
			fillclist();
			fillbookslist();
			save_config_file();
			winremove = NULL;
		} break;
		case 2: /* save */
		{
			base_write(wbsave);
			gtk_widget_destroy(winsave);
			winsave = NULL;
		} break;
	}
}

static void cancel_clicked (GtkObject *object, gint user_data)
{
	switch ( user_data ) {
		case 1: { gtk_widget_destroy (winremove); winremove=NULL;}break;
		case 2: { gtk_widget_destroy (winsave); winsave = NULL;} break;
	}
}


static void setbook_remove(GtkWidget *widget, gint foo)
{
	wbremove = foo;
}

static void setbook_save(GtkWidget *widget, gint foo)
{
	wbsave = foo;
}

GtkWidget* create_book_window (int which)
{
	GtkWidget *win;
	GtkWidget *dialog_vbox;
	GtkWidget *dialog_action_area;
	GtkWidget *boxsel;
	GtkWidget *label=NULL;
	GtkWidget *optionmenu;
	GtkWidget *optionmenu_menu;
	GtkWidget *hbb;
	GtkWidget *ok;
	GtkWidget *cancel;

	win = gtk_dialog_new();
	switch ( which ) {
		case 1:
		{
			gtk_window_set_title (GTK_WINDOW (win), \
					_("Remove a base"));
			label = gtk_label_new (_("Remove which base ?"));
		} break;
		case 2:
		{
			winsave = gtk_dialog_new();
			gtk_window_set_title (GTK_WINDOW (winsave), \
					_("Write a base"));
			label = gtk_label_new (_("Write which base ?"));
		} break;
	}
			
	gtk_window_set_policy (GTK_WINDOW (win), TRUE, TRUE, FALSE);
	dialog_vbox = GTK_DIALOG (win)->vbox;
	gtk_widget_show (dialog_vbox);
	
	boxsel = gtk_vbox_new (FALSE, 0);
	gtk_widget_show (boxsel);
	gtk_box_pack_start (GTK_BOX (dialog_vbox), boxsel, TRUE, TRUE, 0);
	gtk_container_border_width (GTK_CONTAINER (boxsel), 5);

	gtk_widget_show (label);
	gtk_box_pack_start (GTK_BOX (boxsel), label, FALSE, TRUE, 5);

	optionmenu = gtk_option_menu_new ();
	gtk_widget_show (optionmenu);
	gtk_box_pack_start (GTK_BOX (boxsel), optionmenu, TRUE, FALSE, 5);
	optionmenu_menu = gtk_menu_new ();
	
	switch ( which ) {
		case 1:
		{
			optionmenu_menu = create_optionmenu_menu( \
					GTK_SIGNAL_FUNC(setbook_remove));
		} break;
		case 2:
		{
			optionmenu_menu = create_optionmenu_menu( \
					GTK_SIGNAL_FUNC(setbook_save));
		} break;
	}
			
	gtk_option_menu_set_menu(GTK_OPTION_MENU(optionmenu), optionmenu_menu);
	
	dialog_action_area = GTK_DIALOG (win)->action_area;
	gtk_widget_show (dialog_action_area);
	gtk_container_border_width (GTK_CONTAINER (dialog_action_area), 10);
	
	hbb = gtk_hbutton_box_new ();
	gtk_widget_show (hbb);
	gtk_box_pack_start (GTK_BOX (dialog_action_area), hbb, TRUE, TRUE, 5);
	gtk_container_border_width (GTK_CONTAINER (hbb), 5);

	ok = gtk_button_new_with_label (_("OK"));
	gtk_widget_show (ok);
	gtk_signal_connect (GTK_OBJECT(ok),"clicked", \
			GTK_SIGNAL_FUNC(ok_clicked), (gpointer)which );
	gtk_container_add (GTK_CONTAINER (hbb), ok);

	cancel = gtk_button_new_with_label (_("Cancel"));
	gtk_widget_show (cancel);
	gtk_signal_connect (GTK_OBJECT(cancel),"clicked", \
			GTK_SIGNAL_FUNC(cancel_clicked),(gpointer)which );
	gtk_container_add (GTK_CONTAINER (hbb), cancel);

	switch ( which ) {
		case 1: { winremove = win; return winremove; } break;
		case 2: { winsave = win; return winsave; } break;
	}
	return NULL;
}

