/*  Gaby
 *  Copyright (C) 1998 Frederic Peters
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "gaby.h"
#include <gtk/gtk.h>
#include "dialogs.h"
#include "useful.h"
#include "form.h"
#include "main.h"

static GtkWidget *win;
static gint colsearch=0;

static void setsearch(GtkWidget *widget, gint a)
{
	colsearch = a;
}

static void ok_clicked (GtkObject *object, GtkWidget *entry)
{
	GString *st;
	st = g_string_new(gtk_entry_get_text(GTK_ENTRY(entry)));
	shown_record = record_goto_str(st, colsearch, shown_record);
	show_record_inform();
}

static void close_clicked (GtkObject *object, gpointer user_data)
{
	gtk_widget_destroy (win);
	win = NULL;
}

GtkWidget* create_goto_window ()
{
	GtkWidget *dialog_vbox;
	GtkWidget *hbox;
	GtkWidget *optionmenu;
	GtkWidget *optionmenu_menu;
	GtkWidget *entry;
	GtkWidget *dialog_action_area;
	GtkWidget *hbb;
	GtkWidget *butclose, *butok;

	if ( win && win->window ) {
		return win;
	}

	win = gtk_dialog_new ();
	gtk_window_set_title (GTK_WINDOW (win), _("Go to"));
	gtk_window_set_policy (GTK_WINDOW (win), TRUE, TRUE, FALSE);

	dialog_vbox = GTK_DIALOG (win)->vbox;
	gtk_widget_show (dialog_vbox);

	hbox = gtk_hbox_new (FALSE, 0);
	gtk_widget_show (hbox);
	gtk_box_pack_start (GTK_BOX (dialog_vbox), hbox, TRUE, TRUE, 0);
	gtk_container_border_width (GTK_CONTAINER (hbox), 5);

	optionmenu = gtk_option_menu_new ();
	gtk_widget_show (optionmenu);
	gtk_box_pack_start (GTK_BOX (hbox), optionmenu, TRUE, FALSE, 5);
//	gtk_container_border_width (GTK_CONTAINER (optionmenu), 5);
	optionmenu_menu = create_labels_menu(0, GTK_SIGNAL_FUNC(setsearch));
	gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu),optionmenu_menu);

	entry = gtk_entry_new ();
	gtk_widget_show (entry);
	gtk_box_pack_start (GTK_BOX (hbox), entry, TRUE, TRUE, 0);

	dialog_action_area = GTK_DIALOG (win)->action_area;
	gtk_widget_show (dialog_action_area);
	gtk_container_border_width (GTK_CONTAINER (dialog_action_area), 10);

	hbb = gtk_hbutton_box_new ();
	gtk_widget_show (hbb);
	gtk_box_pack_start (GTK_BOX (dialog_action_area), hbb, TRUE, TRUE, 0);

	butok = gtk_button_new_with_label (_("OK"));
	gtk_widget_show (butok);
	gtk_container_add (GTK_CONTAINER (hbb), butok);
	
	gtk_signal_connect (GTK_OBJECT(butok),"clicked", \
			GTK_SIGNAL_FUNC(ok_clicked), (gpointer)entry );

	butclose = gtk_button_new_with_label ("Close");
	gtk_widget_show (butclose);
	gtk_container_add (GTK_CONTAINER (hbb), butclose);
	
	gtk_signal_connect (GTK_OBJECT(butclose),"clicked", \
			GTK_SIGNAL_FUNC(close_clicked), NULL);
	return win;
}

