/*  Gaby
 *  Copyright (C) 1998 Frederic Peters
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "gaby.h"
#include <gtk/gtk.h>
#include "main.h"
#include "form.h"
#include "list.h"
#include "dialogs.h"
#include "menu_callbacks.h"

gboolean show_window(GtkWidget *widget, gint data)
{
	GtkWidget *menuitem;
	
	switch ( data ) {
		case 0: { /* about */
				gtk_widget_show(create_about_window());
			} break;
		case 1: { /* form window */
				gtk_widget_show(create_form_window());
			} break;
		case 2: { /* list window */
				menuitem=gtk_object_get_data( \
					GTK_OBJECT(list_window), "menuitem" );
				gtk_widget_set_sensitive(menuitem, FALSE);
				gtk_widget_show(create_list_window());
			} break;
		case 3: { /* configuration window */
				gtk_widget_show(create_config_window());
			} break;
		case 4: { /* remove book window */
				gtk_widget_show(create_book_window(1));
			} break;
		case 5: { /* save a book */
				gtk_widget_show(create_book_window(2));
			} break;
		case 6: { /* advanced search */
				gtk_widget_show(create_advsearch_window());
			} break;
	}
	return TRUE;
}
/*
void write_a_book(GtkWidget *widget, gint data)
{
	gtk_widget_show(create_savebook_window());
}
*/
gboolean write_allbooks(GtkWidget *widget, gint data)
{
	gboolean dontstop=TRUE;
	gint i=1;
	all_bases = g_list_first(all_bases);
	do {
		base_write(i);
		if ( all_bases->next == NULL ) {
			dontstop = FALSE;
		} else {
			all_bases = g_list_next(all_bases);
			i++;
		}
	} while ( dontstop );
	message_in_statusbar (_("All books had been written on disk") );
	return TRUE;
}

void change_record(GtkWidget *widget, int user_data)
{
	if ( srwc ) { save_record(NULL,0); }

	if ( all_records == NULL || all_records->data == NULL )
		return;

	switch ( user_data ) {
		case 1:
		{
			shown_record--;
			if ( shown_record == -1 ) {
				message_in_statusbar( \
					_("You are on the first record."));
				shown_record = 0;
			}
		} break;
		case 2:	{ shown_record++;             } break;
		case 3:	{ shown_record = -2;          } break;
		case 4:	{ shown_record = 0;           } break;
		case 5:	{ shown_record = MAX_RECORDS; } break;
		case 6:
		{
			gtk_widget_show(create_goto_window());
			return;
		} break;
			
	}
	show_record_inform();
}

void save_record(GtkWidget *widget, int user_data)
{
	int i,j;
	GString *st;
	GString *tmp;
	record *ent;
	st = g_string_new("");
	tmp = g_string_new("");
	if ( shown_record == -2 ) { /* new record */ 
		for (i=0;i<nlabels+1;i++) {
			switch ( ffields[i].type ) {
				case 0:
				{
				tmp = g_string_assign(tmp, \
					gtk_entry_get_text( \
					GTK_ENTRY( ffields[i].widget)));
				} break;
				case 1:
				{
				tmp = g_string_assign( tmp , \
					gtk_editable_get_chars( \
					GTK_EDITABLE(ffields[i].widget),0,-1));
/*					len=gtk_text_get_length(GTK_TEXT( \
						ffields[i].widget));
					tmp = g_string_assign(tmp, "");
					for ( j=0; j<len;j++ ) {
						c = GTK_TEXT_INDEX(GTK_TEXT( \
							ffields[i].widget), i);
						tmp = g_string_append_c(tmp, c);
						
					}
					*/
				} break;
				case 2:
				{
				tmp = g_string_assign(tmp, \
					(GTK_TOGGLE_BUTTON( \
					ffields[i].widget)->active) ? \
					_("Yes") : _("No"));
				} break;
			}
			
			for ( j=0; j<tmp->len;j++ ) {
				switch ( tmp->str[j] ) {
					case '\\' :
					st = g_string_append(st,"\\\\");break;
					case '\n' :
					st = g_string_append(st, "\\n");break;
					case '\r' :
					st = g_string_append(st, "\\r");break;
					case '\t' :
					st = g_string_append(st, "\\t");break;
					case ';' :
					st = g_string_append(st, "\\;");break;
					default :
					st = g_string_append_c(st, tmp->str[j]);
				}
			}
			st = g_string_append_c(st, ';');
		}
		st = g_string_erase(st, (st->len)-1, 1);
		st = g_string_append_c(st, '\n' );

		if ( st->len == nlabels+1 ) {
			g_string_free(st, 1);
			g_string_free(tmp,1);
			return;
		}

		record_add (st, iwb);

		shown_record = MAX_RECORDS;
		show_record_inform();
	} else { /* updated record */
		record_goto(shown_record);
		ent = all_records->data;
		for (i=0;i<nlabels+1;i++) {
			switch ( ffields[i].type ) {
				case 0:
				{
				ent->info[i] = g_string_assign( \
					ent->info[i], \
					gtk_entry_get_text( GTK_ENTRY(\
					ffields[i].widget)));
				} break;
				case 1:
				{
				ent->info[i] = g_string_assign( \
					ent->info[i], gtk_editable_get_chars( \
					GTK_EDITABLE(ffields[i].widget),0,-1));
				} break;
				case 2:
				{
				tmp = g_string_assign(tmp,(GTK_TOGGLE_BUTTON( \
						ffields[i].widget)->active) ? \
						_("Yes") : _("No"));
				ent->info[i] = g_string_assign( \
						ent->info[i],tmp->str);
				} break;
			}
		}
		ent->frombook = iwb;
	}
	g_string_free(st, 1);
	g_string_free(tmp,1);
	fillclist();
}

void remove_record(GtkWidget *widget, int user_data)
{
	if ( ! record_remove(shown_record) )
		return;
	fillclist();
	show_record_inform();
}

void createbook_ok_clicked(GtkWidget *wid, GtkFileSelection *fs)
{
	if (!base_add(gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs)))){
		message_in_statusbar (_("Error loading this book"));
		gtk_widget_destroy(GTK_WIDGET(fs));
		return;
	}
	gtk_widget_destroy(GTK_WIDGET(fs));
	list_books_changed = TRUE;
//	shown_record = 0;
	show_record_inform();
	fillclist();
	fillbookslist();
	save_config_file();
	message_in_statusbar (_("A new book had been added"));
}

void createbook_cancel_clicked(GtkWidget *wid, GtkFileSelection *fs)
{
	gtk_widget_destroy(GTK_WIDGET(fs));
}

void addbase (GtkButton *button, gpointer user_data)
{
	GtkWidget *createbook;
	GtkWidget *ok;
	GtkWidget *cancel;

	createbook = gtk_file_selection_new (_("New book"));
	gtk_container_border_width (GTK_CONTAINER (createbook), 10);
	GTK_WINDOW (createbook)->type = GTK_WINDOW_DIALOG;

	ok = GTK_FILE_SELECTION (createbook)->ok_button;
	gtk_widget_show (ok);
	GTK_WIDGET_SET_FLAGS (ok, GTK_CAN_DEFAULT);
	gtk_signal_connect (GTK_OBJECT (ok), "clicked", \
			GTK_SIGNAL_FUNC (createbook_ok_clicked), \
			(gpointer)createbook);

	cancel = GTK_FILE_SELECTION (createbook)->cancel_button;
	gtk_widget_show (cancel);
	GTK_WIDGET_SET_FLAGS (cancel, GTK_CAN_DEFAULT);
	gtk_signal_connect (GTK_OBJECT (cancel), "clicked", \
			GTK_SIGNAL_FUNC (createbook_cancel_clicked), \
			(gpointer)createbook);

	gtk_widget_show(createbook);
}

gboolean get_full_email(GString *st, int field)
{
	GString *fstname;
	GString *lstname;
	int emfmt=email_format;

	fstname=g_string_new(gtk_entry_get_text(GTK_ENTRY(ffields[0].widget)));
	lstname=g_string_new(gtk_entry_get_text(GTK_ENTRY(ffields[1].widget)));
	
	if ( fstname->len == 0 && lstname->len == 0 ) emfmt = 1;
	st = g_string_append(st, gtk_entry_get_text( \
				GTK_ENTRY(ffields[field].widget)));
	if ( st->len == 0 ) { return FALSE; }
	switch ( emfmt ) {
		case 0:
		{
			st = g_string_append(st, ">");
			st = g_string_prepend(st, "<");
			if ( lstname->len != 0 ) {
				st = g_string_prepend_c(st, ' ');
				st = g_string_prepend(st, lstname->str);
			}
			if ( fstname->len != 0 ) {
				st = g_string_prepend_c(st, ' ');
				st = g_string_prepend(st, fstname->str);
			}
		} break;
		case 1:
		{
/*			st = g_string_append(st, " >");
			st = g_string_prepend(st, " <");*/
		} break;
		case 2:
		{
			st = g_string_append(st, " (");
			if ( lstname->len != 0 ) {
				st = g_string_append(st, lstname->str);
			}
			if ( fstname->len != 0 ) {
				if ( lstname->len != 0 ) {
					st = g_string_append_c(st, ' ');
				}
				st = g_string_append(st, fstname->str);
			}
			st = g_string_append(st, ")");
		} break;
	}
	g_string_free(fstname, 1);
	g_string_free(lstname, 1);
	return TRUE;
}	

gboolean get_phone_number(GString *st, gint field)
{
	GString *tmp;
	st = g_string_assign(st, gtk_entry_get_text( \
				GTK_ENTRY(ffields[field].widget)));
	if ( st->len == 0 ) { return FALSE; }
	tmp = g_string_new("");

	/* now the hard part : make a good number :) */
	
	if ( st->str[0] == '+' ) { /* an international number */
		st = g_string_erase(st, 0, 1);
		if (strncmp(st->str,country_code->str,country_code->len)==0){
			st = g_string_erase(st, 0, country_code->len);
		} else {
			tmp = g_string_append(tmp, in_prefix->str);
			while ( st->str[0] != '-' && st->str[0] != '(' ) {
				tmp = g_string_append_c(tmp, st->str[0]);
				st = g_string_erase(st, 0, 1);
			}
		}
	}
	/* we should now have the international part (if applicable) in tmp
	 * and no more in st
	 * =>
	 * +32(4)263.58.61 -> (4)263.58.61
	 * +32-4-263 58 61 -> -4-263 58 61
	 */
	if ( st->str[0] == '(' || st->str[0] == '-'  || \
			(strncmp(st->str,ld_prefix->str,ld_prefix->len)==0)) {
		if ( tmp->len == 0 ) {
			st = g_string_erase(st, 0, 1);
		} else {
			if (strncmp(st->str,ld_prefix->str,ld_prefix->len)==0) {
				st = g_string_erase(st, 0, ld_prefix->len);
			}
		}
		if ( strncmp(st->str, area_code->str, area_code->len)==0) {
			st = g_string_erase(st, 0, area_code->len);
		} else {
			if ( tmp->len == 0 ) {
				tmp = g_string_append(tmp, ld_prefix->str);
			}
			if ( st->str[0] == '(' ) {
				st = g_string_erase(st, 0, 1);
			}
			while ( st->str[0] != '-' && st->str[0] != ')' && \
					st->str[0] != '/') {
				tmp = g_string_append_c(tmp, st->str[0]);
				st = g_string_erase(st, 0, 1);
			}
		}
	}
	/* we should now stay only have the number in st */
	while ( st->len > 0 ) {
		if ( st->str[0] != '.' && st->str[0] != '/' && \
				st->str[0]!='-' && st->str[0] != ')' && \
				st->str[0]!=' ' ) {
			tmp = g_string_append_c(tmp, st->str[0]);
		}
		st = g_string_erase(st, 0, 1);
	}
	g_print("The number is  : %s\n", tmp->str);
	st = g_string_assign(st, tmp->str);
	g_string_free(tmp, 1);
	return TRUE;
}

void action_record(GtkWidget *widget, int user_data)
{
	int std=0;
	int i=0;
	GString *sdq;
	GString *cmd = NULL;
	sdq = g_string_new("");
	
	switch (user_data & (192) ) {
		case 64: /* Phone to */
		{
			cmd = g_string_new(cmd_phone->str);
			if ( get_phone_number(sdq, user_data-64) == FALSE ) {
				std=-1; break;
			}
			i=1;
			while ( !(cmd->str[i] == 't' && cmd->str[i-1] == '$') \
					&& i < cmd->len )
				i++;
			cmd = g_string_erase(cmd, i-1, 2);
			cmd = g_string_insert(cmd, i-1, sdq->str);
		} break;
		case 128: /* Mail to */
		{
			cmd = g_string_new(cmd_email->str);
			if ( get_full_email(sdq, user_data-128) == FALSE ) { 
				std=-1; break;
				/* I should perhaps show a message */
			}
			i=1;
			while ( !(cmd->str[i] == 'e' && cmd->str[i-1] == '$') \
					&& i < cmd->len )
				i++;
			cmd = g_string_erase(cmd, i-1, 2);
			cmd = g_string_insert(cmd, i-1, sdq->str);
		} break;
		case 3: /* Browse to */
		{
			cmd = g_string_new(cmd_browse->str);
			sdq = g_string_assign(sdq, gtk_entry_get_text( \
				GTK_ENTRY(ffields[POS_WEB].widget)));
			if ( sdq->len == 0 ) { std=-1; break; }
			
			while ( !(cmd->str[i] == 'w' && cmd->str[i-1] == '$') \
					&& i < cmd->len )
				i++;
			cmd = g_string_erase(cmd, i-1, 2);
			cmd = g_string_insert(cmd, i-1, sdq->str);
/*			echo "if netscape -remote \"openUrl($w)\"; then exec /bin/true ; else exec netscape \"%number\"; fi" | sh &
 */
			std = -1;
		} break;
		default:
		{
			std = -1;
		} break;
	}

	if ( std == 0 && cmd != NULL && cmd->len != 0 ) {
		if (fork()) return;
		setsid();
		if(execl("/bin/sh","sh","-c", cmd->str, NULL)==-1){exit(100);}
		exit(0);
	}
	if ( cmd != NULL ) { g_string_free(cmd, 1); }
	g_string_free(sdq, 1);
}

void print_records(GtkWidget *widget, int user_data)
{
	gtk_widget_show(create_output_dialog(0, ""));
}

void sort_event(GtkWidget *widget, int user_data)
{
	base_sort(user_data);
	fillclist();
	show_record_inform();
}

void savelistas_ok_clicked(GtkWidget *wid, GtkFileSelection *fs)
{
	gint type;
	type = (gint)gtk_object_get_data(GTK_OBJECT(fs), "type");
	gtk_widget_show( create_output_dialog(type+1, \
		gtk_file_selection_get_filename (GTK_FILE_SELECTION (fs))) );
	gtk_widget_destroy(GTK_WIDGET(fs));
}

void savelistas_cancel_clicked(GtkWidget *wid, GtkFileSelection *fs)
{
	gtk_widget_destroy(GTK_WIDGET(fs));
}

void output_list(GtkWidget *widget, int user_data)
{
	GtkWidget *filesel, *ok, *cancel;
	
	filesel = gtk_file_selection_new (_("Save list as"));
	gtk_container_border_width (GTK_CONTAINER (filesel), 10);
	GTK_WINDOW (filesel)->type = GTK_WINDOW_DIALOG;
	gtk_object_set_data(GTK_OBJECT(filesel), "type", (gpointer)user_data);

	ok = GTK_FILE_SELECTION (filesel)->ok_button;
	gtk_widget_show (ok);
	GTK_WIDGET_SET_FLAGS (ok, GTK_CAN_DEFAULT);
	gtk_signal_connect (GTK_OBJECT (ok), "clicked", \
			GTK_SIGNAL_FUNC (savelistas_ok_clicked), \
			(gpointer)filesel);

	cancel = GTK_FILE_SELECTION (filesel)->cancel_button;
	gtk_widget_show (cancel);
	GTK_WIDGET_SET_FLAGS (cancel, GTK_CAN_DEFAULT);
	gtk_signal_connect (GTK_OBJECT (cancel), "clicked", \
			GTK_SIGNAL_FUNC (savelistas_cancel_clicked), \
			(gpointer)filesel);
	
	switch ( user_data ) {
		case 0: /* LaTeX */
		{
			gtk_file_selection_set_filename( \
				GTK_FILE_SELECTION(filesel), "list.tex");
		} break;
		case 1: /* HTML */
		{
			gtk_file_selection_set_filename( \
				GTK_FILE_SELECTION(filesel), "list.html");
		} break;
	}

	gtk_widget_show(filesel);
}

